Attribute VB_Name = "M_Smazinka"
Option Explicit
Global Const SPS_SIMULATION = 0
Global PO As Integer
Global Ip As String

' liefert einen Fehler- bzw. Status-String
Function smazWinSock_Init(socket As Winsock, Ip As String, Port As Integer) As String
Dim s As String
On Error GoTo Err

    If socket.State = sckOpen Then
       socket.Close
    End If
    
    If socket.State <> sckError Then
       socket.RemoteHost = Ip
       socket.RemotePort = Port
       socket.Connect
       smazWinSock_Init = ">> Init OK, Host:" + socket.RemoteHost
    Else
       smazWinSock_Init = ">> Init Fehler"
    End If
    
Exit Function
Err: smazWinSock_Init = ">> Init Exeption: " + Err.Description
End Function

' liefert einen Fehler- bzw. Status-String
' von der SPS kommt:
' TYP_Parameter
' Typen sind:
'       1: RESU Ergebnis (vom Schrauber: gut,schlecht)
'       2: STAT Statusmeldung (Schrauber luft)
'       3: ERRO Fehlermeldung (Notaus, Druckluft etc.)
Function smazWinSock_Receive(socket As Winsock, Rec_Typ As Integer, Rec_Data As String) As String
Dim s As String
Dim bytesTotal As Integer
Dim sDataRecieved As String
Dim sTyp As String
On Error GoTo Err

    socket.GetData sDataRecieved, vbString
    bytesTotal = Len(sDataRecieved)
    Debug.Print CStr(bytesTotal) + " Bytes: " + sDataRecieved

    If bytesTotal > 6 Then
        sTyp = Left(sDataRecieved, 4)
        
        Rec_Data = Mid(sDataRecieved, 6)
        Select Case sTyp
        Case "RESU":    Rec_Typ = 1
        Case "STAT":    Rec_Typ = 2
        Case "ERRO":    Rec_Typ = 3
        Case Else:      Rec_Typ = 3: Rec_Data = "undefinierte Daten"
        End Select
        smazWinSock_Receive = ">> Receive OK"
    Else
        smazWinSock_Receive = ">> Receive zu wenig Daten empfangen " + CStr(bytesTotal) + " Bytes"
    End If

Exit Function
Err: smazWinSock_Receive = ">> Receive Exeption: " + Err.Description
End Function

' liefert einen Fehler- bzw. Status-String
Function smazWinSock_Send(socket As Winsock, Programmnummer As Integer) As String
Dim s As String
On Error GoTo Err

    socket.SendData "DATA_PRGNR_" + CStr(Programmnummer) + "_##"
    smazWinSock_Send = ">> Send OK"
Exit Function
Err: smazWinSock_Send = ">> Send Exeption: " + Err.Description
End Function

' liefert einen Fehler- bzw. Status-String
Function smazWinSock_Exit(socket As Winsock) As String
Dim s As String
On Error GoTo Err

    socket.Close
    smazWinSock_Exit = ">> Exit begonnen"
    
Exit Function
Err: smazWinSock_Exit = ">> Exit Exeption: " + Err.Description
End Function

