Attribute VB_Name = "Module1"

Global Const sIP = "192.168.0.62"
Global Const iPort = 1099

Global AktiveForm As Integer

' max. length is 288 Bytes, max message length is 255 + 8 Bytes
Type MSG_STRUC
  rx As Byte
  tx As Byte
  ln As Byte
  nr As Byte
  a As Byte
  f As Byte
  b As Byte
  e As Byte
  data(254) As Byte
  dummy(24) As Byte   'for compatibility with older definitions (288 Bytes)
End Type

Global s_msg As MSG_STRUC
Global CmdByte(6) As Byte
' Global sDataRecieved As String
Global s(288) As Byte


Sub InitMsg(msg As MSG_STRUC)
Dim i As Integer

    CmdByte(0) = &H31  ' DB
    CmdByte(1) = &H33  ' M
    CmdByte(2) = &H34  ' E/A
    CmdByte(3) = &H34  ' E/A
    CmdByte(4) = &H35  ' Z
    CmdByte(5) = &H36  ' T
    CmdByte(6) = &H32  ' SPS

    msg.rx = 3
    msg.tx = 255
    msg.ln = 8
    msg.nr = 1
    msg.a = 0
    msg.f = 0
    msg.b = &H34
    msg.e = 0
    msg.data(0) = 2 ' MPI 2 ist CPU
    msg.data(1) = 0  ' 0=In, 1=Out
    msg.data(2) = 4 ' addr.L
    msg.data(3) = 0 ' addr.H 25.07.2004
    msg.data(4) = 0 'IX
    msg.data(5) = 2  ' count
    msg.data(6) = 5 ' UINT
    msg.data(7) = 1 ' read

End Sub

Sub MsgStrukturFllen(msg As MSG_STRUC, cmd As Byte, DBNr As Byte, Start As Byte, anzahl As Byte, Schreiben As Boolean)
    msg.nr = msg.nr + 1
    msg.rx = 3
    msg.tx = 255
    msg.a = 0
    msg.f = 0
    msg.b = cmd ' &H34
    msg.e = 0
    
    msg.data(0) = 2 ' MPI 2 ist CPU
    
    If Schreiben = False Then
        msg.ln = 8
        msg.data(1) = 0  ' 0=In, 1=Out
        msg.data(7) = 1 ' read
    Else
        msg.ln = 8 + anzahl
        msg.data(1) = 1  ' 0=In, 1=Out
        msg.data(7) = 2 ' write
    End If
    msg.data(2) = Start ' 4 ' addr.L
    msg.data(3) = 0 ' addr.H 25.07.2004
    msg.data(4) = DBNr 'IX
    msg.data(5) = anzahl '2  ' count
    msg.data(6) = 5 ' UINT
End Sub


Sub MsgStruktur_MitNettodatenFllen(msg As MSG_STRUC)
Dim i As Integer

    s(0) = msg.rx
    s(1) = msg.tx
    s(2) = msg.ln
    s(3) = msg.nr
    s(4) = msg.a
    s(5) = msg.f
    s(6) = msg.b
    s(7) = msg.e

    For i = 0 To 7
        s(i + 8) = msg.data(i)
        Debug.Print "S"; i + 8; "="; s(i + 8)
    Next
    
End Sub


Function Abfrage(s() As Byte, anzahl As Byte, winSocke As Winsock) As String
Dim ss As String
Dim i As Integer
Dim n As Integer
Dim c As Integer
Dim cmd As Byte
                               
    Abfrage = "Abfrage..."
    ss = ""
    
    If s(15) = 1 Then ' 1=Lesen
        n = 15
    Else
        n = 15 + anzahl
    End If
    
    For i = 0 To n
        ss = ss & Chr(s(i))
        Debug.Print "SS"; s(i)
    Next
        
    show_data32 s
    
    If winSocke.State = sckConnected Then
       winSocke.SendData ss
       Abfrage = "Abfrage: gesendet"
    Else
       Abfrage = "Abfrage: Keine Host-Verbindung"
    End If
End Function


Sub show_data(s As String)
Dim i As Integer
Dim X As Integer
Dim c As Integer
    Debug.Print "__________________"
    X = Len(s)
    If X > 20 Then X = 20
    For i = 1 To X
        c = Asc(Mid(s, i, 1))
        Debug.Print c; " "; Hex(c)
    Next
    Debug.Print "- - - - -"
End Sub

Sub show_data32(s() As Byte)
Dim i As Integer
Dim c As Integer
    For i = 0 To 24
        c = s(i)
        Debug.Print Hex(c); " ";
    Next
    Debug.Print
End Sub


Sub show_netto(s As String, li As ListBox)
Dim i As Integer
Dim n As Integer
Dim c As Integer
Dim ss As String
    
    n = Len(s)
    If n > 16 Then
        For i = 17 To n
            c = i - 17
            ss = ss & Right("00" & Hex(c), 2) & " "
        Next
        li.AddItem ss & "  " & CStr(n - 16) + " Nettodaten"
        Debug.Print ss & "  " & CStr(n - 16) + " Nettodaten"
        ss = ""
        For i = 17 To n
            c = Asc(Mid(s, i, 1))
            ss = ss & Right("00" & Hex(c), 2) & " "
        Next
        li.AddItem ss
        Debug.Print ss
    Else
        c = Asc(Mid(s, 5, 1))
        ' c = Asc(Mid(s, 7, 1))
        li.AddItem "keine Daten Error=" & CStr(c) & " " & Right("00" & Hex(c), 2) & "h"
    End If
End Sub
